function [pct puntos total] = master ()

puntos = 0.0;
total  = 0.0;

% Datos necesarios para los ejercicios

A = magic(3);

% Cargar fichero de resultados

try 
  resultados;
catch
  disp(['AVISO: Existe un problema en su fichero de respuestas a los ejercicios. Por favor, revise posibles errores...']);  
  return;
end

% Cargar fichero con las respuestas correctas

masterKey;

% Batera de ejercicios

ejercicios(1).valor = 20;
ejercicios(1).check = @check1;

ejercicios(2).valor = 20;
ejercicios(2).check = @check2;

ejercicios(3).valor = 20;
ejercicios(3).check = @check3;

ejercicios(4).valor = 20;
ejercicios(4).check = @check4;

ejercicios(5).valor = 20;
ejercicios(5).check = @check5;

% Comprobacin de resultados

for i=1:length(ejercicios)

  valor = ejercicios(i).valor;

  disp(['Ejercicio ',num2str(i),' [',num2str(valor),'%]']);

  ok = ejercicios(i).check(key,respuestas);

  pts = valor*ok;

  disp([' - Puntuacin: ',num2str(pts),'/', num2str(valor),'.']);

  puntos = puntos + pts;
  total  = total + valor;

end

% Resultados finales

pct = puntos/total;

disp ([ 'TOTAL' ] );

disp ([' - Puntuacin final: ',num2str(puntos),'/', num2str(total),'.']);
disp ([' - Porcentaje de acierto: ', num2str(100*pct), '%'] );


%%%%%


function ok = assertEquals (expected, actual, margin, message)

if min(abs((actual-expected)./expected))>margin
   disp(['ERROR: ',message]);
end

ok = min(abs((actual-expected)./expected)<=margin);

%%%%%

function pct = check1 (key, respuestas)

pct = assertEquals(key.avogadro, respuestas.avogadro, 0.0000001, 'Asegrese de especificar, al menos, 7 dgitos significativos para el nmero de Avogadro.');

%%%%%

function pct = check2 (key, respuestas)

pct = assertEquals(key.expresion, respuestas.expresion, 0.0001, 'Respuesta incorrecta.');

%%%%%

function pct = check3 (key, respuestas)

pct = assertEquals(key.pi, respuestas.pi, 0.000001, 'Respuesta incorrecta.');

%%%%%

function pct = check4 (key, respuestas)

pct = assertEquals(key.magic, respuestas.magic, 0.0, 'Respuesta incorrecta.');

%%%%%

function pct = check5 (key, respuestas)

q(1) = assertEquals(key.fila, respuestas.fila, 0.0, 'Fila incorrecta.');
q(2) = assertEquals(key.columna, respuestas.columna, 0.0, 'Columna incorrecta.');
q(3) = min(assertEquals(key.seccion, respuestas.seccion, 0.0, 'Seccin incorrecta.'));

pct = mean(q);