function [pct puntos total] = test ()

puntos = 0;
total  = 0;

% 20% 

disp('figura.m');

puntos = puntos + 20.0*testFigura();

disp('macro.m');

puntos = puntos + 20.0*testScript();

disp('hipoteca.m');

puntos = puntos + 60.0*testHipoteca();

% Respuestas a los ejercicios

try 
  A = magic(3);
  resultados;
catch
  disp(['AVISO: Existe un problema en su fichero de respuestas a los ejercicios. Por favor, revise posibles errores...']);  
end

% Resultados

total = 100;

pct = puntos / total;

disp ([ 'Puntuacin total = ', num2str(100*pct), '%'] );



%%%%%%

function [pct ok total] = testFigura ()

total = 20;
ok = 0;

try 

  figura;

  if exist('figura.png')
     ok = ok + 20;
  else
     disp(['- No se cre correctamente el fichero "figura.m".']);
  end;

catch
  disp(['[figura.m] Error: No fue posible crear su figura.']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ figura.m']);

pct = ok / total;


%%%%%%

function [pct ok total] = testScript ()

total = 20;
ok = 0;

try 

  macro;


  for i=1:7
     
      if factores(i)==i
         ok = ok + 1;
      else
         disp(['- Factor ',num2str(i),' incorrecto.']);
      end

      if productos(i)==142857*i
         ok = ok + 1;
      else
         disp(['- Producto ',num2str(i),' x 142857 incorrecto.']);
      end
  end

  ok = ok + 6;

catch
  disp(['[macro.m] Error: No fue posible ejecutar su macro.']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ macro.m']);

pct = ok / total;


%%%%%

function [pct ok total] = testHipoteca ()

total = 60;
ok = 0;

try 

  [cuota capital intereses] = hipoteca(70919.43, 4.62, 20);

  if abs(cuota-453.2781)<0.01
     ok = ok + 10;
  else
     disp(['- Error al calcular la cuota mensual de una hipoteca a 20 aos de 70919.43 euros al 4.62% de inters.']);
  end
  
  if (floor(100*cuota) == 45328) & (ceil(100*cuota) == 45328)
     ok = ok + 10;
  else
     disp(['- Error al redondear al cntimo la cuota mensual de una hipoteca a 20 aos de 70919.43 euros al 4.62% de inters.']);
  end

  amortizacion = [180.24 180.93 181.63 182.33 183.03 183.74 184.44 185.15 185.87 186.58 187.30 188.02];
  interes      = [273.04 272.35 271.65 270.95 270.25 269.54 268.84 268.13 267.41 266.70 265.98 265.26];

  if length(capital)==20*12
     ok = ok + 5;
  else
     disp(['- Su funcin no calcula el capital amortizado cada mes (un vector de tamao 12*20 para una hipoteca a 20 aos).']);
  end
   
  if length(intereses)==20*12
     ok = ok + 5;
  else
     disp(['- Su funcin no calcula el inters devengado mes a mes (un vector de tamao 12*20 para una hipoteca a 20 aos).']);
  end

  if max(abs(intereses(1:12)-interes))<0.01
     ok = ok + 10;
  else
     disp(['- Su funcin no calcula correctamente el inters devengado mes a mes.']);
  end

  if max(abs(intereses(1:12)-interes))<0.001
     ok = ok + 10;
  else
     disp(['- Su funcin no redondea al cntimo los intereses devengados mes a mes.']);
  end

  if max(abs(capital(1:12)-amortizacion))<0.001
     ok = ok + 10;
  else
     disp(['- Su funcin no calcula adecuadamente el capital amortizado cada mes.']);
  end

catch
  disp(['[hipoteca.m] Error: No fue posible comprobar correctamente su funcin.']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ hipoteca.m']);

pct = ok / total;